# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1GetModelVersionsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'model': 'V1Model',
        'model_versions': 'list[V1ModelVersion]',
        'pagination': 'V1Pagination'
    }

    attribute_map = {
        'model': 'model',
        'model_versions': 'modelVersions',
        'pagination': 'pagination'
    }

    def __init__(self, model=None, model_versions=None, pagination=None):  # noqa: E501
        """V1GetModelVersionsResponse - a model defined in Swagger"""  # noqa: E501

        self._model = None
        self._model_versions = None
        self._pagination = None
        self.discriminator = None

        if model is not None:
            self.model = model
        if model_versions is not None:
            self.model_versions = model_versions
        if pagination is not None:
            self.pagination = pagination

    @property
    def model(self):
        """Gets the model of this V1GetModelVersionsResponse.  # noqa: E501

        The model requested.  # noqa: E501

        :return: The model of this V1GetModelVersionsResponse.  # noqa: E501
        :rtype: V1Model
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this V1GetModelVersionsResponse.

        The model requested.  # noqa: E501

        :param model: The model of this V1GetModelVersionsResponse.  # noqa: E501
        :type: V1Model
        """

        self._model = model

    @property
    def model_versions(self):
        """Gets the model_versions of this V1GetModelVersionsResponse.  # noqa: E501

        The list of returned model versions.  # noqa: E501

        :return: The model_versions of this V1GetModelVersionsResponse.  # noqa: E501
        :rtype: list[V1ModelVersion]
        """
        return self._model_versions

    @model_versions.setter
    def model_versions(self, model_versions):
        """Sets the model_versions of this V1GetModelVersionsResponse.

        The list of returned model versions.  # noqa: E501

        :param model_versions: The model_versions of this V1GetModelVersionsResponse.  # noqa: E501
        :type: list[V1ModelVersion]
        """

        self._model_versions = model_versions

    @property
    def pagination(self):
        """Gets the pagination of this V1GetModelVersionsResponse.  # noqa: E501

        Pagination information of the full dataset.  # noqa: E501

        :return: The pagination of this V1GetModelVersionsResponse.  # noqa: E501
        :rtype: V1Pagination
        """
        return self._pagination

    @pagination.setter
    def pagination(self, pagination):
        """Sets the pagination of this V1GetModelVersionsResponse.

        Pagination information of the full dataset.  # noqa: E501

        :param pagination: The pagination of this V1GetModelVersionsResponse.  # noqa: E501
        :type: V1Pagination
        """

        self._pagination = pagination

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1GetModelVersionsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1GetModelVersionsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
