# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1Metrics(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'num_inputs': 'int',
        'validation_metrics': 'object'
    }

    attribute_map = {
        'num_inputs': 'numInputs',
        'validation_metrics': 'validationMetrics'
    }

    def __init__(self, num_inputs=None, validation_metrics=None):  # noqa: E501
        """V1Metrics - a model defined in Swagger"""  # noqa: E501

        self._num_inputs = None
        self._validation_metrics = None
        self.discriminator = None

        if num_inputs is not None:
            self.num_inputs = num_inputs
        if validation_metrics is not None:
            self.validation_metrics = validation_metrics

    @property
    def num_inputs(self):
        """Gets the num_inputs of this V1Metrics.  # noqa: E501

        Number of inputs to the model.  # noqa: E501

        :return: The num_inputs of this V1Metrics.  # noqa: E501
        :rtype: int
        """
        return self._num_inputs

    @num_inputs.setter
    def num_inputs(self, num_inputs):
        """Sets the num_inputs of this V1Metrics.

        Number of inputs to the model.  # noqa: E501

        :param num_inputs: The num_inputs of this V1Metrics.  # noqa: E501
        :type: int
        """

        self._num_inputs = num_inputs

    @property
    def validation_metrics(self):
        """Gets the validation_metrics of this V1Metrics.  # noqa: E501

        Metrics calculated on the validation set.  # noqa: E501

        :return: The validation_metrics of this V1Metrics.  # noqa: E501
        :rtype: object
        """
        return self._validation_metrics

    @validation_metrics.setter
    def validation_metrics(self, validation_metrics):
        """Sets the validation_metrics of this V1Metrics.

        Metrics calculated on the validation set.  # noqa: E501

        :param validation_metrics: The validation_metrics of this V1Metrics.  # noqa: E501
        :type: object
        """

        self._validation_metrics = validation_metrics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1Metrics, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1Metrics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
