# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1ModelVersion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'model': 'V1Model',
        'checkpoint': 'V1Checkpoint',
        'version': 'int',
        'creation_time': 'datetime'
    }

    attribute_map = {
        'model': 'model',
        'checkpoint': 'checkpoint',
        'version': 'version',
        'creation_time': 'creationTime'
    }

    def __init__(self, model=None, checkpoint=None, version=None, creation_time=None):  # noqa: E501
        """V1ModelVersion - a model defined in Swagger"""  # noqa: E501

        self._model = None
        self._checkpoint = None
        self._version = None
        self._creation_time = None
        self.discriminator = None

        if model is not None:
            self.model = model
        if checkpoint is not None:
            self.checkpoint = checkpoint
        if version is not None:
            self.version = version
        if creation_time is not None:
            self.creation_time = creation_time

    @property
    def model(self):
        """Gets the model of this V1ModelVersion.  # noqa: E501

        The model the version is related to.  # noqa: E501

        :return: The model of this V1ModelVersion.  # noqa: E501
        :rtype: V1Model
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this V1ModelVersion.

        The model the version is related to.  # noqa: E501

        :param model: The model of this V1ModelVersion.  # noqa: E501
        :type: V1Model
        """

        self._model = model

    @property
    def checkpoint(self):
        """Gets the checkpoint of this V1ModelVersion.  # noqa: E501

        The checkpoint of the model version.  # noqa: E501

        :return: The checkpoint of this V1ModelVersion.  # noqa: E501
        :rtype: V1Checkpoint
        """
        return self._checkpoint

    @checkpoint.setter
    def checkpoint(self, checkpoint):
        """Sets the checkpoint of this V1ModelVersion.

        The checkpoint of the model version.  # noqa: E501

        :param checkpoint: The checkpoint of this V1ModelVersion.  # noqa: E501
        :type: V1Checkpoint
        """

        self._checkpoint = checkpoint

    @property
    def version(self):
        """Gets the version of this V1ModelVersion.  # noqa: E501

        The version number.  # noqa: E501

        :return: The version of this V1ModelVersion.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this V1ModelVersion.

        The version number.  # noqa: E501

        :param version: The version of this V1ModelVersion.  # noqa: E501
        :type: int
        """

        self._version = version

    @property
    def creation_time(self):
        """Gets the creation_time of this V1ModelVersion.  # noqa: E501

        The time the model version was created.  # noqa: E501

        :return: The creation_time of this V1ModelVersion.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """Sets the creation_time of this V1ModelVersion.

        The time the model version was created.  # noqa: E501

        :param creation_time: The creation_time of this V1ModelVersion.  # noqa: E501
        :type: datetime
        """

        self._creation_time = creation_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1ModelVersion, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1ModelVersion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
