# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1ResourcePoolDetail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'aws': 'V1ResourcePoolAwsDetail',
        'gcp': 'V1ResourcePoolGcpDetail',
        'priority_scheduler': 'V1ResourcePoolPrioritySchedulerDetail'
    }

    attribute_map = {
        'aws': 'aws',
        'gcp': 'gcp',
        'priority_scheduler': 'priorityScheduler'
    }

    def __init__(self, aws=None, gcp=None, priority_scheduler=None):  # noqa: E501
        """V1ResourcePoolDetail - a model defined in Swagger"""  # noqa: E501

        self._aws = None
        self._gcp = None
        self._priority_scheduler = None
        self.discriminator = None

        if aws is not None:
            self.aws = aws
        if gcp is not None:
            self.gcp = gcp
        if priority_scheduler is not None:
            self.priority_scheduler = priority_scheduler

    @property
    def aws(self):
        """Gets the aws of this V1ResourcePoolDetail.  # noqa: E501


        :return: The aws of this V1ResourcePoolDetail.  # noqa: E501
        :rtype: V1ResourcePoolAwsDetail
        """
        return self._aws

    @aws.setter
    def aws(self, aws):
        """Sets the aws of this V1ResourcePoolDetail.


        :param aws: The aws of this V1ResourcePoolDetail.  # noqa: E501
        :type: V1ResourcePoolAwsDetail
        """

        self._aws = aws

    @property
    def gcp(self):
        """Gets the gcp of this V1ResourcePoolDetail.  # noqa: E501


        :return: The gcp of this V1ResourcePoolDetail.  # noqa: E501
        :rtype: V1ResourcePoolGcpDetail
        """
        return self._gcp

    @gcp.setter
    def gcp(self, gcp):
        """Sets the gcp of this V1ResourcePoolDetail.


        :param gcp: The gcp of this V1ResourcePoolDetail.  # noqa: E501
        :type: V1ResourcePoolGcpDetail
        """

        self._gcp = gcp

    @property
    def priority_scheduler(self):
        """Gets the priority_scheduler of this V1ResourcePoolDetail.  # noqa: E501


        :return: The priority_scheduler of this V1ResourcePoolDetail.  # noqa: E501
        :rtype: V1ResourcePoolPrioritySchedulerDetail
        """
        return self._priority_scheduler

    @priority_scheduler.setter
    def priority_scheduler(self, priority_scheduler):
        """Sets the priority_scheduler of this V1ResourcePoolDetail.


        :param priority_scheduler: The priority_scheduler of this V1ResourcePoolDetail.  # noqa: E501
        :type: V1ResourcePoolPrioritySchedulerDetail
        """

        self._priority_scheduler = priority_scheduler

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1ResourcePoolDetail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1ResourcePoolDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
