# coding: utf-8

"""
    Determined API (Beta)

    Determined helps deep learning teams train models more quickly, easily share GPU resources, and effectively collaborate. Determined allows deep learning engineers to focus on building and training models at scale, without needing to worry about DevOps or writing custom code for common tasks like fault tolerance or experiment tracking.  You can think of Determined as a platform that bridges the gap between tools like TensorFlow and PyTorch --- which work great for a single researcher with a single GPU --- to the challenges that arise when doing deep learning at scale, as teams, clusters, and data sets all increase in size.  # noqa: E501

    OpenAPI spec version: 0.1
    Contact: community@determined.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1TrialsSampleResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'trials': 'list[V1TrialsSampleResponseTrial]',
        'promoted_trials': 'list[int]',
        'demoted_trials': 'list[int]'
    }

    attribute_map = {
        'trials': 'trials',
        'promoted_trials': 'promotedTrials',
        'demoted_trials': 'demotedTrials'
    }

    def __init__(self, trials=None, promoted_trials=None, demoted_trials=None):  # noqa: E501
        """V1TrialsSampleResponse - a model defined in Swagger"""  # noqa: E501

        self._trials = None
        self._promoted_trials = None
        self._demoted_trials = None
        self.discriminator = None

        self.trials = trials
        self.promoted_trials = promoted_trials
        self.demoted_trials = demoted_trials

    @property
    def trials(self):
        """Gets the trials of this V1TrialsSampleResponse.  # noqa: E501

        A historical or incremental series of data points for the trials.  # noqa: E501

        :return: The trials of this V1TrialsSampleResponse.  # noqa: E501
        :rtype: list[V1TrialsSampleResponseTrial]
        """
        return self._trials

    @trials.setter
    def trials(self, trials):
        """Sets the trials of this V1TrialsSampleResponse.

        A historical or incremental series of data points for the trials.  # noqa: E501

        :param trials: The trials of this V1TrialsSampleResponse.  # noqa: E501
        :type: list[V1TrialsSampleResponseTrial]
        """
        if trials is None:
            raise ValueError("Invalid value for `trials`, must not be `None`")  # noqa: E501

        self._trials = trials

    @property
    def promoted_trials(self):
        """Gets the promoted_trials of this V1TrialsSampleResponse.  # noqa: E501

        IDs of trials that are newly included in the data.  # noqa: E501

        :return: The promoted_trials of this V1TrialsSampleResponse.  # noqa: E501
        :rtype: list[int]
        """
        return self._promoted_trials

    @promoted_trials.setter
    def promoted_trials(self, promoted_trials):
        """Sets the promoted_trials of this V1TrialsSampleResponse.

        IDs of trials that are newly included in the data.  # noqa: E501

        :param promoted_trials: The promoted_trials of this V1TrialsSampleResponse.  # noqa: E501
        :type: list[int]
        """
        if promoted_trials is None:
            raise ValueError("Invalid value for `promoted_trials`, must not be `None`")  # noqa: E501

        self._promoted_trials = promoted_trials

    @property
    def demoted_trials(self):
        """Gets the demoted_trials of this V1TrialsSampleResponse.  # noqa: E501

        IDs of trials that are no loger included in the top N trials.  # noqa: E501

        :return: The demoted_trials of this V1TrialsSampleResponse.  # noqa: E501
        :rtype: list[int]
        """
        return self._demoted_trials

    @demoted_trials.setter
    def demoted_trials(self, demoted_trials):
        """Sets the demoted_trials of this V1TrialsSampleResponse.

        IDs of trials that are no loger included in the top N trials.  # noqa: E501

        :param demoted_trials: The demoted_trials of this V1TrialsSampleResponse.  # noqa: E501
        :type: list[int]
        """
        if demoted_trials is None:
            raise ValueError("Invalid value for `demoted_trials`, must not be `None`")  # noqa: E501

        self._demoted_trials = demoted_trials

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1TrialsSampleResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1TrialsSampleResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
